﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=4.01
@EndOfDesignText@
'Class module
Sub Class_Globals
	Private ws As WebSocket
	Private timer1 As Timer
	'these variables will be set automatically.
	Private TxtNumber As JQueryElement 'matches an element with id = "txtnumber"
	Private Result As JQueryElement
	Private ServerTime As JQueryElement
	Type GuessMyNumberState (Number As Int)
	Private state As GuessMyNumberState
End Sub

Public Sub Initialize

End Sub

Private Sub WebSocket_Connected (WebSocket1 As WebSocket)
	Log("Connected")
	ws = WebSocket1
	Dim session As HttpSession = ws.UpgradeRequest.GetSession
	If session.HasAttribute("state") = False Then
		state.Initialize
		state.Number = Rnd(1, 101)
		session.SetAttribute("state", state)
		Log($"Creating new state. Number = ${state.Number}"$)
	Else
		state = session.GetAttribute("state")
		Log($"Reusing previous state. Number = ${state.Number}"$)
	End If
	timer1.Initialize("timer1", 1000)
	timer1.Enabled = True
End Sub

Private Sub WebSocket_Disconnected
	timer1.Enabled = False
	Log("Disconnected")
End Sub

Sub btnGuess_Click (Params As Map)
	Dim number As String = TxtNumber.GetVal.Value
	If IsNumber(number) Then
		Dim n As Int = number
		If n > state.Number Then
			Result.SetHtml("My number is smaller.")
		Else If n < state.Number Then
			Result.SetHtml("My number is larger.")
		Else
			Result.SetHtml("<b>Well done!!!</b>")
		End If
	Else
		Result.SetHtml("Please enter a valid number.")
	End If
	TxtNumber.RunMethod("select", Null)
End Sub

Sub Timer1_Tick
	ServerTime.SetHtml("Server time: " & DateTime.Time(DateTime.Now))
	ws.Flush 'required here as this is a server event
End Sub

Sub txtNumber_KeyUp(Params As Map)
	If Params.Get("which") = 13 Then
		btnGuess_Click (Null)
	End If
End Sub

Sub btnReset_Click (Params As Map)
	state.Number = Rnd(1, 101)
	Log($"Reset number (${state.Number})"$)
End Sub
